#include <vector>
#include <stdexcept>

template <typename T>
class Stack
{
public:
	void push(T const&);
	void pop();
	T top() const;
	bool empty() const
	{
		return data_.empty();
	}
private:
	std::vector<T> data_;
};

template <typename T>
void Stack<T>::push(T const& data)
{
	data_.push_back(data);
}

template <typename T>
void Stack<T>::pop()
{
	if(empty())
		throw std::out_of_range("stack empty");

	data_.pop_back();
}

template <typename T>
T Stack<T>::top() const
{
	if(empty())
		throw std::out_of_range("stack empty");

	return data_.back();
}